% test_ogm.m
% test pgm_restart version of OGM

m = 50;
n = 6;
s = 0;
tau = 0;
niter = 100;


% generate problem  
rng(0)
A = randn(m,n);
xtrue = randn(n,1);
indx = randperm(n);
xtrue(indx(1:s)) = 0; % zero the "s" smallest
sigma = sqrt(0.1);
b = A * xtrue + sigma * randn(m,1);

% function for computing first-order information
F_cost = @(x) 0.5 * norm(A*x-b,2)^2 + tau * norm(x,1);
f_grad = @(x) A' * (A*x - b);
g_prox = @(x,c) sign(x) .* max(abs(x)-c*tau, 0);

% function parameters
f_L = eigs(A'*A, [], 1);
f_mu = 0.; % zero is a lower bound

xhat = A \ b;

x0 = xtrue;;
mom = 2;
restart = 0;
bsig = 1;
niter = 100;
seq = 1;

[xg, fg, rg] = gm_restart(x0, F_cost, f_grad, f_L, f_mu, ...
	mom, restart, bsig, niter, seq);

[xp, fp, rp] = pgm_restart(x0, F_cost, f_grad, f_L, f_mu, g_prox, ...
	mom, restart, bsig, niter);

f0 = F_cost(xhat);
ffun = @(f) max((f - f0) / f0, 1e-17);
semilogy(0:niter, ffun(fg), 'b-', ...
	0:niter, ffun(fp), 'r-')
legend('OGM from GM', 'OGM from PGM')
